/*
    TUIpeer works in conjunction with an implementation of java.awt.Toolkit
    to provide a Text User Interface for programs using the Java AWT.

    Copyright (C) 1997-2000  Stuart D. Gathman <stuart@bmsi.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#pragma interface
#include "component.h"

class Choice: public Component {
  struct StrList;
  StrList &txt;
  int cursel,maxwidth;
  bool inPopup;
public:
  Choice();
  ~Choice();
  void remoteMethod(int cmd);
  void addItem(const string &,int);
  void remove(int);
  void select(int);
  int countItems() const;
  int getSelectedIndex() const;
  const char *operator[](int);
  const string &getItem(int) const;
  const string &getSelectedItem() const;
  void paint(DrawingContext *);
  void getfocus();
  void key(int k);
};

class ListComponent: public Component {
  class StringList &txt;
  class LongSet &selected;
  int topline, curline;
  bool multi;
public:
  ListComponent();
  ~ListComponent();
  void remoteMethod(int cmd);
  void addItem(const string &,int);
  void remove(int beg,int end);
  void select(int);
  void deselect(int);
  void removeAll();
  void setMultipleMode(bool b) { multi = b; }
  void makeVisible(int);
  void paint(DrawingContext *);
  void key(int);
  void getfocus();
};
