/*
    TUIpeer works in conjunction with an implementation of java.awt.Toolkit
    to provide a Text User Interface for programs using the Java AWT.

    Copyright (C) 1997-2000  Stuart D. Gathman <stuart@bmsi.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#pragma interface
#include "remotepeer.h"

struct RemoteComponent: RemotePeer {
  RemoteComponent(class Component *);
  virtual void remoteMethod(int cmd);
  ~RemoteComponent();
protected:
  class Component *comp;
};

struct RemoteContainer: RemoteComponent {
  RemoteContainer(class ContainerComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteContainer();
};

struct RemoteWindow: RemoteContainer {
  RemoteWindow(class WindowComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteWindow();
};

struct RemoteDialog: RemoteWindow {
  RemoteDialog(class Dialog *);
  virtual void remoteMethod(int cmd);
  ~RemoteDialog();
};

struct RemoteFrame: RemoteDialog {
  RemoteFrame(class FrameComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteFrame();
};

struct RemoteLabel: RemoteComponent {
  RemoteLabel(class LabelComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteLabel();
};

struct RemoteButton: RemoteLabel {
  RemoteButton(class Button *);
  ~RemoteButton();
};

struct RemoteCheckbox: RemoteButton {
  RemoteCheckbox(class CheckBox *);
  virtual void remoteMethod(int cmd);
  ~RemoteCheckbox();
};

struct RemoteTextComponent: RemoteComponent {
  RemoteTextComponent(class TextComponent *);
  virtual void remoteMethod(int cmd);
  ~RemoteTextComponent();
};

struct RemoteTextField: RemoteTextComponent {
  RemoteTextField(class TextField *);
  virtual void remoteMethod(int cmd);
  ~RemoteTextField();
};

struct RemoteTextArea: RemoteTextComponent {
  RemoteTextArea(class TextArea *);
  virtual void remoteMethod(int cmd);
  ~RemoteTextArea();
};
