/*
    TUIpeer works in conjunction with an implementation of java.awt.Toolkit
    to provide a Text User Interface for programs using the Java AWT.

    Copyright (C) 1997-2000  Stuart D. Gathman <stuart@bmsi.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#pragma interface
#include "component.h"

class Scrollbar: public Component {
  int value;
  int visible;
  int min, max;
  int taboffset;
  int tabsize;
  int size;
public:
  void remoteMethod(int cmd);
  enum Orientation { HORZ, VERT };
  Scrollbar(Orientation);
  void reshape(int,int,int,int);
  void setValue(int val);
  void setValues(int val,int vis,int min,int max);
  int getValue() { return value; }
  int getVisible() { return visible; }
  int getMinimum() { return min; }
  int getMaximum() { return max; }
  void paint(DrawingContext *);
  void getfocus();
  void key(int k);
  ~Scrollbar();
private:
  Orientation dir;
};
